<html>
<head>
<title>OgreGLHardwarePixelBuffer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7b8a29f58b064e3a63f570f2fc89729.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLHardwarePixelBuffer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLHardwarePixelBuffer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __GLPIXELBUFFER_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __GLPIXELBUFFER_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLPrerequisites_8h.html">OgreGLPrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwarePixelBuffer_8h.html">OgreHardwarePixelBuffer.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00035"></a><a class="code" href="classOgre_1_1GLHardwarePixelBuffer.html">00035</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLHardwarePixelBuffer.html">GLHardwarePixelBuffer</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwarePixelBuffer.html" title="Specialisation of HardwareBuffer for a pixel buffer.">HardwarePixelBuffer</a>
<a name="l00036"></a>00036     {
<a name="l00037"></a>00037     <span class="keyword">protected</span>:  
<a name="l00039"></a>00039         <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> lockImpl(<span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> lockBox,  <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options);
<a name="l00040"></a>00040 
<a name="l00042"></a>00042         <span class="keywordtype">void</span> unlockImpl(<span class="keywordtype">void</span>);
<a name="l00043"></a>00043         
<a name="l00044"></a>00044         <span class="comment">// Internal buffer; either on-card or in system memory, freed/allocated on demand</span>
<a name="l00045"></a>00045         <span class="comment">// depending on buffer usage</span>
<a name="l00046"></a><a class="code" href="classOgre_1_1GLHardwarePixelBuffer.html#a36b8467001b0e41abe2d0bf1311f1ae7">00046</a>         <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> <a class="code" href="classOgre_1_1GLHardwarePixelBuffer.html#a36b8467001b0e41abe2d0bf1311f1ae7">mBuffer</a>;
<a name="l00047"></a><a class="code" href="classOgre_1_1GLHardwarePixelBuffer.html#a73271a29fb78db5b566e31551d2ba1ba">00047</a>         GLenum <a class="code" href="classOgre_1_1GLHardwarePixelBuffer.html#a73271a29fb78db5b566e31551d2ba1ba">mGLInternalFormat</a>; <span class="comment">// GL internal format</span>
<a name="l00048"></a><a class="code" href="classOgre_1_1GLHardwarePixelBuffer.html#af1a01e9c7bad8098398c2fd5a922a069">00048</a>         <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> <a class="code" href="classOgre_1_1GLHardwarePixelBuffer.html#af1a01e9c7bad8098398c2fd5a922a069">mCurrentLockOptions</a>;
<a name="l00049"></a>00049         
<a name="l00050"></a>00050         <span class="comment">// Buffer allocation/freeage</span>
<a name="l00051"></a>00051         <span class="keywordtype">void</span> allocateBuffer();
<a name="l00052"></a>00052         <span class="keywordtype">void</span> freeBuffer();
<a name="l00053"></a>00053         <span class="comment">// Upload a box of pixels to this buffer on the card</span>
<a name="l00054"></a>00054         <span class="keyword">virtual</span> <span class="keywordtype">void</span> upload(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;data, <span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;dest);
<a name="l00055"></a>00055         <span class="comment">// Download a box of pixels from the card</span>
<a name="l00056"></a>00056         <span class="keyword">virtual</span> <span class="keywordtype">void</span> download(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;data);
<a name="l00057"></a>00057     <span class="keyword">public</span>:
<a name="l00059"></a>00059         <a class="code" href="classOgre_1_1GLHardwarePixelBuffer.html">GLHardwarePixelBuffer</a>(<span class="keywordtype">size_t</span> mWidth, <span class="keywordtype">size_t</span> mHeight, <span class="keywordtype">size_t</span> mDepth,
<a name="l00060"></a>00060                 <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> mFormat,
<a name="l00061"></a>00061                 <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage);
<a name="l00062"></a>00062         
<a name="l00064"></a>00064         <span class="keywordtype">void</span> blitFromMemory(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;src, <span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;dstBox);
<a name="l00065"></a>00065         
<a name="l00067"></a>00067         <span class="keywordtype">void</span> blitToMemory(<span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;srcBox, <span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;dst);
<a name="l00068"></a>00068         
<a name="l00069"></a>00069         ~<a class="code" href="classOgre_1_1GLHardwarePixelBuffer.html">GLHardwarePixelBuffer</a>();
<a name="l00070"></a>00070         
<a name="l00073"></a>00073         <span class="keyword">virtual</span> <span class="keywordtype">void</span> bindToFramebuffer(GLenum attachment, <span class="keywordtype">size_t</span> zoffset);
<a name="l00074"></a><a class="code" href="classOgre_1_1GLHardwarePixelBuffer.html#a37003c1d500e64b8a656930fb7dd905c">00074</a>         GLenum <a class="code" href="classOgre_1_1GLHardwarePixelBuffer.html#a37003c1d500e64b8a656930fb7dd905c">getGLFormat</a>() { <span class="keywordflow">return</span> mGLInternalFormat; }
<a name="l00075"></a>00075     };
<a name="l00076"></a>00076 
<a name="l00079"></a><a class="code" href="classOgre_1_1GLTextureBuffer.html">00079</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLTextureBuffer.html" title="Texture surface.">GLTextureBuffer</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1GLHardwarePixelBuffer.html">GLHardwarePixelBuffer</a>
<a name="l00080"></a>00080     {
<a name="l00081"></a>00081     <span class="keyword">public</span>:
<a name="l00083"></a>00083         <a class="code" href="classOgre_1_1GLTextureBuffer.html" title="Texture surface.">GLTextureBuffer</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;baseName, GLenum target, GLuint <span class="keywordtype">id</span>, GLint face, 
<a name="l00084"></a>00084             GLint level, <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">Usage</a> usage, <span class="keywordtype">bool</span> softwareMipmap, <span class="keywordtype">bool</span> writeGamma, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> fsaa);
<a name="l00085"></a>00085         ~<a class="code" href="classOgre_1_1GLTextureBuffer.html" title="Texture surface.">GLTextureBuffer</a>();
<a name="l00086"></a>00086         
<a name="l00088"></a>00088         <span class="keyword">virtual</span> <span class="keywordtype">void</span> bindToFramebuffer(GLenum attachment, <span class="keywordtype">size_t</span> zoffset);
<a name="l00090"></a>00090         <a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a>* getRenderTarget(<span class="keywordtype">size_t</span>);
<a name="l00092"></a>00092         <span class="keyword">virtual</span> <span class="keywordtype">void</span> upload(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;data, <span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;dest);
<a name="l00094"></a>00094         <span class="keyword">virtual</span> <span class="keywordtype">void</span> download(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;data);
<a name="l00095"></a>00095   
<a name="l00097"></a>00097         <span class="keyword">virtual</span> <span class="keywordtype">void</span> blitFromMemory(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;src_orig, <span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;dstBox);
<a name="l00098"></a>00098         
<a name="l00100"></a><a class="code" href="classOgre_1_1GLTextureBuffer.html#ace0896964d4b6808b5cf3d6c9562aef5">00100</a>         <span class="keywordtype">void</span> _clearSliceRTT(<span class="keywordtype">size_t</span> zoffset)
<a name="l00101"></a>00101         {
<a name="l00102"></a>00102             mSliceTRT[zoffset] = 0;
<a name="l00103"></a>00103         }
<a name="l00105"></a>00105         <span class="keywordtype">void</span> copyFromFramebuffer(<span class="keywordtype">size_t</span> zoffset);
<a name="l00107"></a>00107         <span class="keywordtype">void</span> blit(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwarePixelBufferSharedPtr.html" title="Shared pointer implementation used to share pixel buffers.">HardwarePixelBufferSharedPtr</a> &amp;src, <span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;srcBox, <span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;dstBox);
<a name="l00108"></a>00108         <span class="comment">// Blitting implementation</span>
<a name="l00109"></a>00109         <span class="keywordtype">void</span> blitFromTexture(<a class="code" href="classOgre_1_1GLTextureBuffer.html" title="Texture surface.">GLTextureBuffer</a> *src, <span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;srcBox, <span class="keyword">const</span> <a class="code" href="structOgre_1_1Box.html" title="Structure used to define a box in a 3-D integer space.">Image::Box</a> &amp;dstBox);
<a name="l00110"></a>00110     <span class="keyword">protected</span>:
<a name="l00111"></a>00111         <span class="comment">// In case this is a texture level</span>
<a name="l00112"></a><a class="code" href="classOgre_1_1GLTextureBuffer.html#a19b401d869dbeae1b9d65e51cd643bee">00112</a>         GLenum <a class="code" href="classOgre_1_1GLTextureBuffer.html#a19b401d869dbeae1b9d65e51cd643bee">mTarget</a>;
<a name="l00113"></a><a class="code" href="classOgre_1_1GLTextureBuffer.html#ae717392ec5bc98af7fda311e90ee696a">00113</a>         GLenum <a class="code" href="classOgre_1_1GLTextureBuffer.html#ae717392ec5bc98af7fda311e90ee696a">mFaceTarget</a>; <span class="comment">// same as mTarget in case of GL_TEXTURE_xD, but cubemap face for cubemaps</span>
<a name="l00114"></a><a class="code" href="classOgre_1_1GLTextureBuffer.html#a44b65f0c304834235bf3925dac6273c1">00114</a>         GLuint <a class="code" href="classOgre_1_1GLTextureBuffer.html#a44b65f0c304834235bf3925dac6273c1">mTextureID</a>;
<a name="l00115"></a><a class="code" href="classOgre_1_1GLTextureBuffer.html#a5e60b02d3d9fa1b63927dcefcd2e420f">00115</a>         GLint <a class="code" href="classOgre_1_1GLTextureBuffer.html#a5e60b02d3d9fa1b63927dcefcd2e420f">mFace</a>;
<a name="l00116"></a><a class="code" href="classOgre_1_1GLTextureBuffer.html#a89dcfd99d698f982309c726b1d987653">00116</a>         GLint <a class="code" href="classOgre_1_1GLTextureBuffer.html#a89dcfd99d698f982309c726b1d987653">mLevel</a>;
<a name="l00117"></a><a class="code" href="classOgre_1_1GLTextureBuffer.html#a68166491d5916256c1a320fc493020fa">00117</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLTextureBuffer.html#a68166491d5916256c1a320fc493020fa">mSoftwareMipmap</a>;       <span class="comment">// Use GLU for mip mapping</span>
<a name="l00118"></a>00118         
<a name="l00119"></a><a class="code" href="classOgre_1_1GLTextureBuffer.html#a3ecf5b8040048094cf609aa21e0abcb3">00119</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;RenderTexture*&gt;::type</a> <a class="code" href="classOgre_1_1GLTextureBuffer.html#a3ecf5b8040048094cf609aa21e0abcb3">SliceTRT</a>;
<a name="l00120"></a><a class="code" href="classOgre_1_1GLTextureBuffer.html#a7e40ad94e97cc2d36e5890a079c8d5de">00120</a>         <a class="code" href="classOgre_1_1GLTextureBuffer.html#a3ecf5b8040048094cf609aa21e0abcb3">SliceTRT</a> <a class="code" href="classOgre_1_1GLTextureBuffer.html#a7e40ad94e97cc2d36e5890a079c8d5de">mSliceTRT</a>;
<a name="l00121"></a>00121     };
<a name="l00124"></a><a class="code" href="classOgre_1_1GLRenderBuffer.html">00124</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLRenderBuffer.html" title="Renderbuffer surface.">GLRenderBuffer</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1GLHardwarePixelBuffer.html">GLHardwarePixelBuffer</a>
<a name="l00125"></a>00125     {
<a name="l00126"></a>00126     <span class="keyword">public</span>:
<a name="l00127"></a>00127         <a class="code" href="classOgre_1_1GLRenderBuffer.html" title="Renderbuffer surface.">GLRenderBuffer</a>(GLenum format, <span class="keywordtype">size_t</span> width, <span class="keywordtype">size_t</span> height, GLsizei numSamples);
<a name="l00128"></a>00128         ~<a class="code" href="classOgre_1_1GLRenderBuffer.html" title="Renderbuffer surface.">GLRenderBuffer</a>();
<a name="l00129"></a>00129         
<a name="l00131"></a>00131         <span class="keyword">virtual</span> <span class="keywordtype">void</span> bindToFramebuffer(GLenum attachment, <span class="keywordtype">size_t</span> zoffset);
<a name="l00132"></a>00132     <span class="keyword">protected</span>:
<a name="l00133"></a>00133         <span class="comment">// In case this is a render buffer</span>
<a name="l00134"></a><a class="code" href="classOgre_1_1GLRenderBuffer.html#a2a495aa06458de8af18f6c3071ec05a4">00134</a>         GLuint <a class="code" href="classOgre_1_1GLRenderBuffer.html#a2a495aa06458de8af18f6c3071ec05a4">mRenderbufferID</a>;
<a name="l00135"></a>00135     };
<a name="l00136"></a>00136 }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
